Description

This guide is building the Zimbra Collaborative Suite 8.0.8 Open Source Edition on an Ubuntu 14.04 x64 virtual machine with 1GB of
RAM.

Initial Setup

e Add the Zimbra user:

sudo mkdir /opt/zimbra
sudo adduser —--home /opt/zimbra zimbra
sudo su - zimbra

o [nstall git:
apt—-get install git
e Obtain the git ssh access keys:

mkdir -p /tmp/zimbra-git

cd /tmp/zimbra-git

wget http://files2.zimbra.com/downloads/git-fusion/zimbra-git-ssh.tgz
tar xfz zimbra-git-ssh.tgz

* Add the access keys to your own user account:

cd ~/.ssh
cp /tmp/zimbra-git/id_rsa_git*

e Add the following ~/.ssh/config. Create the file if it doesn't exist:

Host zimbra-git
User public
Hostname git.zimbra.com
IdentityFile ~/.ssh/id_rsa_git
IdentitiesOnly yes
Port 1067

e Ensure the permissions on the config file are correct

chmod 600 ~/.ssh/config
Obtaining the source to Zimbra Collaboration Suite
The source code for ZCS is retrieved from git.zimbra.com as described above.
* To obtain the source:
mkdir -p ~/git
cd ~/git
git clone git@zimbra-git:zimbra-foss
Source for the "main" branch
* main is the development branch.

The 'main’ branch, (often referred to as mainline) contains the latest code - if your interested in seeing pre-release software check it
out.

It is constantly in flux (for instance we might stagger spec files to avoid the need to always rebuild ThirdParty), if you're hitting a error
in the Zimbra build side the first thing to do is re-sync, as we typically resolve these fast.

It is the default branch in use after doing a checkout of zimbra-foss

Listing available branches

¢ The zimbra-foss repo contains all the available release branches. You can obtain a list of the branches via:

git branch -a

*I main-foss
remotes/origin/HEAD -> origin/main-foss
remotes/origin/frank-foss
remotes/origin/franklin-5010-foss
remotes/origin/franklin-5011-foss
remotes/origin/franklin-5012-foss
remotes/origin/franklin-5013-foss
remotes/origin/franklin-5014-foss
remotes/origin/franklin-5015-foss
remotes/origin/franklin-5016-foss
remotes/origin/franklin-5017-foss
remotes/origin/franklin-5018-foss
remotes/origin/franklin-5019-foss
remotes/origin/franklin-5020-foss

The branch with a * in front of it is your active checkout.
Changing the active checkout

To change the active branch, you use the git checkout command, and supply the release you are interested in.

* For example, to switch to the IRONMAIDEN 8 release branch, one would execute:

cd ~/git/zimbra-foss
git checkout ironmaiden-foss

Updating an existing clone

¢ To update an already existing clone:
cd ~/git/zimbra-foss
git pull

Prepare the Build Environment

e |nstall some prerequisites and development packages:

sudo apt-get install build-essential autoconf libtool perl5.14 gettext automake cmake flex bis
on software-properties—common python-software-properties unzip zliblg zliblg-dev expat libexpa
tl-dev libpopt0O libpopt-dev libmysglclient-dev libcurlé4-openssl-dev libsasl2-2 libgssapi3-heim
dal libsasl2-modules—gssapi-heimdal libsasl2-dev libldap2-dev libpcre3 1libpcre3-dev 1libltdl3-
dev libbz2-dev bzip2 1libbz2-1.0 apache2-dev phpb5-dev postfix-dev libdspam7-dev libopendkim-dev
libncurses5-dev libidnll curl fetchmail libgmp3-dev libxml2 libstdc++6 openssl libssl-dev 1lib
aio-dev liblwp-useragent-determined-perl

¢ |nstall a few more dependencies, to be safe:

sudo aptitude build-dep altermime amavisd-new apache2 aspell postfix-cluebringer libxml2 phpb5
openldap openssl rrdtool rsync sendmail snmp libtcmalloc-minimald4 zeromg mysgl-server curl cla
mav cyrus-sasl2 postfix dspam opendkim

* Now install a few 32-bit compatibility packages, if running on a 64 bit system:

sudo apt-get install 1ibc6:1386 libgccl:1386 gcc-4.6-base:1386 libstdc++5:1386 libstdc++6:1386
libasound2:1386 libgtk2.0-0:1386 libxtst6:1386

Prepare JDK 7

* Download JDK 7u60 locally then upload the local copy to the Zimbra server:
scp -P 4440 ~/Downloads/jdk-7u60-linux-x64.tar.gz zimbra@zimbra.example.com:/opt/zimbra/
* Next, on the Zimbra server, add JDK 7u60 to the Zimbra build path:

cp ~/jdk-7u60-linux-x64.tar.gz ~/git/zimbra-foss/ThirdPartyBuilds/x86_64/java/jdk-1.7.0_60.tgz
sudo cp ~/jdk-7u60-linux-x64.tar.gz /usr/local/
sudo tar xzf /usr/local/jdk-1.7.0_60.tgz

* Now, download JCE 6 locally, then upload the local copy to the Zimbra server:
scp -P 4440 ~/Downloads/jce_policy-6.zip zimbra@zimbra.example.com:/opt/zimbra/
e Add JCE 6 policy to the JDK 7u60 build path:

cp Jjce_policy-6.zip ~/git/zimbra-foss/ThirdPartyBuilds/x86_64/java/
cd ~/git/zimbra-foss/ThirdPartyBuilds/x86_64/java/
unzip jce_policy-6.zip

Install Apache Ant
¢ |nstall apache ant:

cd /usr/local

sudo wget http://mirror.cogentco.com/pub/apache//ant/binaries/apache-ant-1.9.4-bin.tar.gz
sudo tar xzf apache-ant-1.9.4-bin.tar.gz

sudo 1ln -s /usr/local/apache-ant-1.9.4 /usr/local/ant

Add Java and ANT to the system environment:

e Make the following changes to the /etc/environment file:
sudo vi /etc/environment

PATH="/ust/local/sbin:/ust/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games:/usr/local/java/bin:/usr/local/ant/bin"

Fix a few linked object problems:
e | needed to create a few symbolic links that Zimbra will be looking for:
sudo 1n -s /1lib/x86_64-1linux-gnu/libncurses.so.5 /usr/lib/libncurses.so
sudo 1ln -s /1lib/x86_64-linux-gnu/libz.so.1l /usr/lib/libz.so
sudo 1ln -s /usr/lib/x86_64-linux—gnu/libltdl.so /usr/lib/libltdl.so
sudo 1ln -s /1lib/x86_64-1linux—-gnu/libpcre.so.3 /usr/lib/libpcre.so
sudo 1ln -s /1ib/x86_64-1linux—gnu/libexpat.so.l /usr/lib/libexpat.so

sudo 1ln -s /lib/x86_64-1linux-gnu/libpopt.so.0 /usr/lib/libpopt.so
sudo 1n -s /usr/lib/libperl.so.5.14 /usr/lib/libperl.so

Building Zimbra Collaboration Server

To build Zimbra Collaboration Server, the "buildZCSH.sh" script can be used, that is located in the ZimbraBuild directory after the
checkout completes.

e Since the server already has the various required binaries and libraries installed, run:

cd ~/git/zimbra-foss/ZimbraBuild
./buildzCS.sh -t

* | used the following CPAN repository, since | am not a fan of yahoo (the default):

http://ftp.osuosl.org/pub/CPAN/

Resources

e http://wiki.zimbra.com/wiki/Building_Zimbra_using_Git
¢ http://www.oracle.com/technetwork/java/javase/archive-139210.html

History

#1 - 07/29/2014 02:00 PM - Daniel Curtis

- Description updated

#2 - 07/29/2014 03:55 PM - Daniel Curtis
- Description updated

- % Done changed from 10 to 40
http://ftp.osuosl.org/pub/CPAN/
http://wiki.zimbra.com/wiki/Building_Zimbra_using_Git
http://www.oracle.com/technetwork/java/javase/archive-139210.html

#3 - 07/29/2014 04:48 PM - Daniel Curtis
- Description updated

#4 - 07/29/2014 05:25 PM - Daniel Curtis
- File jre-7u60-linux-x64.tar.gz added

- Description updated

#5 - 07/30/2014 08:37 AM - Daniel Curtis
- File jdk-7u60-linux-x64.tar.gz added
- File jce_policy-6.zip added

- Description updated

#6 - 07/30/2014 08:53 AM - Daniel Curtis

- Description updated

#7 - 08/01/2014 09:49 AM - Daniel Curtis
- Description updated

- % Done changed from 40 to 60

#8 - 08/01/2014 10:31 AM - Daniel Curtis

- Description updated

#9 - 08/01/2014 02:24 PM - Daniel Curtis

- Description updated

#10 - 08/03/2014 09:31 AM - Daniel Curtis

- Description updated

#11 - 08/04/2014 08:18 AM - Daniel Curtis

- Description updated

#12 - 08/04/2014 08:33 AM - Daniel Curtis

- Description updated

#13 - 08/05/2014 01:40 PM - Daniel Curtis

- Description updated

~/git/zimbra-foss/ThirdPartyBuilds/x86_64/java

#14 - 08/05/2014 02:04 PM - Daniel Curtis

- Description updated

#15 - 08/05/2014 02:28 PM - Daniel Curtis

- Description updated

#16 - 08/05/2014 02:33 PM - Daniel Curtis

- Subject changed from Installing Zimbra Collaboration Server from Source on Ubuntu to Installing Zimbra Collaboration Server from Source on
Ubuntu 12.04

- Description updated

#17 - 08/06/2014 09:00 AM - Daniel Curtis

- Description updated

#18 - 08/06/2014 09:41 AM - Daniel Curtis

- Description updated

04/16/2024 5/6



#19 - 08/07/2014 04:14 PM - Daniel Curtis

- Subject changed from Installing Zimbra Collaboration Server from Source on Ubuntu 12.04 to Installing Zimbra Collaboration Server from Source on

Ubuntu
- Description updated

- Status changed from New to In Progress

#20 - 02/15/2015 09:02 PM - Daniel Curtis
- Project changed from 96 to GNU/Linux Administration

- Category set to Mail Server

#21 - 11/15/2015 02:56 PM - Daniel Curtis

- Status changed from In Progress to Suspended

Files

jre-7u60-linux-x64.tar.gz 44.8 MB 07/30/2014 Daniel Curtis

jdk-7u60-linux-x64.tar.gz 136 MB 07/30/2014 Daniel Curtis

jce_policy-6.zip 8.89 KB 07/30/2014 Daniel Curtis
